import nanotec.*;
/*Mit diesem Programm wird eine Referenzfahrt auf Block durchgeführt. Dazu muss als Fahrprofil die externe Referenzfahrt ausgewählt sein. Vor der Fahrt wird der "Phasenstrom während der Fahrt" auf 20% gesetzt.
  Wenn die Abweichung von Soll- zu Istposition <> 10 ist, stoppt der Motor und der Zählerstand wird auf 0 gesetzt. Danach wird der Phasenstrom wieder auf den Ausgangswert gesetzt.
  
  With this program it is possible to to make a reverence run on mechanical block. For this function, the profile external reference run must be selected. Before the start of the program, the "phase current while driving" is set to 20%. 
  If the deviation from nominal to actual position is <> 10, the motor stops and the counter is set to 0. Then, the phase current is reset to the initial value.  
  */
class Referenzfahrt_auf_Block
{	
	public static void main() {
		
		int current = drive.GetCurrent();	//übernimmt den eingestellten "Phasenstrom während der Fahrt", takes over the "phase current during movement"
		
		while(true)
		{	
			if(drive.GetMode()==4)			//Modusabfrage externe Referenzfahrt, reading operation mode reference run external
				{drive.SetCurrent(20);		//setzt Phasenstrom auf 20%, set phase current to 20%
				while (drive.GetMode()==4)	//Modusabfrage externe Referenzfahrt, reading operation mode reference run external
					{	
					if(((drive.GetDemandPosition()-drive.GetEncoderPosition())>10)||	//Vergleicht die aktuelle Position mit der Encoderposition ob die Abweichung >10 oder <-10 ist
						((drive.GetDemandPosition()-drive.GetEncoderPosition())<-10))	//compares the current position with the encoder position whether the deviation is >10 or <-10
						
						{drive.StopDrive(0);		//stoppt die Fahrt mit der quickstop Bremsrampe, stopping the actual drive with quickstop brake ramp
							util.Sleep(200);		//Wartezeit für Stop, waiting time for stop
							drive.SetPosition(0);	//setzte Position 0, set target position 0
						}
					}	
		
				}
			if(drive.GetCurrent()!=current)	//liest den aktuellen Stromwert aus und vergleicht ob er dem am Anfang eingestellten Phasenstrom entspricht, wenn nicht, dann setzt er den Phasenstrom zurück auf diesen Wert, 
											//reading the actual current value, and compares whether it corresponds to the set at the beginning of the phase current, if not, then it sets the phase current back to that value
			{drive.SetCurrent(current);		//setzt den Phasenstrom auf den am Anfang eingestellten Phasenstrom zurück, sets the phase current back to the phase current set at the beginning
			}
		}
	}
}			